searchNodes=[{"doc":"Elastic is a thin veneer over HTTPotion to help you talk to your Elastic Search stores.Elastic provides five main ways of talking to the stores:Elastic.Document.API: Adds functions to a module to abstract away some of the mess of actions on an index.Elastic.Index: Functions for working with indexes.Elastic.Bulk: Provides functions for bulk creating or updating documents in an ElasticSearch store.Elastic.Scroller: A server which works with Elastic Search's Scroll API.Elastic.HTTP: A very thin veneer / low-level API over HTTPotion and Jason to make queries to your Elastic Search store.ConfigurationYou can configure the way Elastic behaves by using the following configuration options:base_url: Where your Elastic Search instance is located. Defaults to http://localhost:9200.index_prefix: A prefix to use for all indexes. Only used when using the Document API, or Elastic.Index.use_mix_env: Adds Mix.env to an index, so that the index name used is something like dev_answer. Can be used in conjunction with index_prefix to get things like company_dev_answer as the index name.timeout: How long to wait before timing out requests. Default is 30 seconds.AWS ConfigurationIf your Elastic Search store is hosted on AWS, there are configuration options for that:config :elastic, base_url: &quot;https://your-amazon-es-endpoint-goes-here&quot;, basic_auth: {&quot;username&quot;, &quot;password&quot;}, aws: %{ enabled: true, access_key_id: &quot;ACCESS_KEY_ID_GOES_HERE&quot;, secret_access_key: &quot;SECRET_ACCESS_KEY_GOES_HERE&quot;, region: &quot;REGION_GOES_HERE&quot; }Elastic will then use the AWSAuth library to sign URLs for requests to this store.","ref":"Elastic.html","title":"Elastic","type":"module"},{"doc":"","ref":"Elastic.html#base_url/0","title":"Elastic.base_url/0","type":"function"},{"doc":"","ref":"Elastic.html#basic_auth/0","title":"Elastic.basic_auth/0","type":"function"},{"doc":"Used to make requests to ElasticSearch's bulk API.All of index, create and update take a list of tuples.The order of elements in each tuple is this:IndexTypeID (not required for index bulk action)DataHere's how to use create: Elastic.Bulk.create( [ {Elastic.Index.name(&quot;answer&quot;), &quot;answer&quot;, &quot;id-goes-here&quot;, %{text: &quot;This is an answer&quot;}} ] )It's worth noting here that you can choose to pass nil as the ID in these index requests; ElasticSearch will automatically generate an ID for you.For create requests, an ID must be provided.","ref":"Elastic.Bulk.html","title":"Elastic.Bulk","type":"module"},{"doc":"Makes bulk create requests to ElasticSearch. For more information see documentation on Elastic.Bulk.","ref":"Elastic.Bulk.html#create/1","title":"Elastic.Bulk.create/1","type":"function"},{"doc":"Makes bulk index requests to ElasticSearch. For more information see documentation on Elastic.Bulk.","ref":"Elastic.Bulk.html#index/1","title":"Elastic.Bulk.index/1","type":"function"},{"doc":"Makes bulk update requests to ElasticSearch. For more information see documentation on Elastic.Bulk.","ref":"Elastic.Bulk.html#update/1","title":"Elastic.Bulk.update/1","type":"function"},{"doc":"The Document API provides some helpers for interacting with documents.The Document API extracts away a lot of the repetition of querying / indexing of a particular index. Here's an example:defmodule Answer do @es_type &quot;answer&quot; @es_index &quot;answer&quot; use Elastic.Document.API defstruct id: nil, text: [] endYou may also specify the index at query/insertion as the last (optional) argument to all Document functions. You will receive warnings if @es_index is undefined in the using module, but you may either ignore these or specify @es_index &quot;N/A&quot; or other unused value if a default index does not make sense for your collection, such as permission based partitioning, or per-company partitioning in a SaaS application.IndexThen you can index a new Answer by doing:Answer.index(1, %{text: &quot;This is an answer&quot;})orAnswer.index(1, %{text: &quot;This is an answer&quot;}, &quot;explicit_named_index&quot;)if not using default index behavior. All examples below may also be modified the same way if using an explicit index.SearchingThe whole point of Elastic Search is to search for things, and there's a function for that:Answer.search(%{ query: %{ match: %{text: &quot;answer&quot;} }, })The query syntax is exactly like the JSON you've come to know and love from using Elastic Search, except it's Elixir maps.This will return a list of Answer structs.[ %Answer{id: 1, text: &quot;This is an answer&quot;}, ... ]If you want the raw search result, use raw_search instead:Answer.raw_search(%{ query: %{ match: %{text: &quot;answer&quot;} }, })This will return the raw result, without the wrapping of the structs:{:ok, 200, [ %{&quot;_id&quot; =&gt; &quot;1&quot;, &quot;_index&quot; =&gt; &quot;answer&quot;, &quot;_source&quot; =&gt; %{&quot;text&quot; =&gt; &quot;This is an answer&quot;}, &quot;_type&quot; =&gt; &quot;answer&quot;, &quot;_version&quot; =&gt; 1, &quot;found&quot; =&gt; true} } ... ] }CountingCounting works the same as searching, but instead of returning all the hits, it'll return a number.Answer.count(%{ query: %{ match: %{text: &quot;answer&quot;} }, })GetAnd you can get that answer with:Answer.get(1)This will return an Answer struct:%Answer{id: 1, text: &quot;This is an answer&quot;}Raw GetIf you want the raw result, use raw_get instead:Answer.raw_get(1)This returns the raw data from Elastic Search, without the wrapping of the struct:{:ok, 200, %{&quot;_id&quot; =&gt; &quot;1&quot;, &quot;_index&quot; =&gt; &quot;answer&quot;, &quot;_source&quot; =&gt; %{&quot;text&quot; =&gt; &quot;This is an answer&quot;}, &quot;_type&quot; =&gt; &quot;answer&quot;, &quot;_version&quot; =&gt; 1, &quot;found&quot; =&gt; true} } }UpdatingYou can update the answer by using update (or index, since update is just an &quot;alias&quot;)Answer.update(1, %{text: &quot;This is an answer&quot;})DeletingDeleting a document from the index is as easy as:Answer.delete(1)","ref":"Elastic.Document.API.html","title":"Elastic.Document.API","type":"module"},{"doc":"Used to make raw calls to Elastic Search.Each function returns a tuple indicating whether or not the request succeeded or failed (:ok or :error), the status code of the response, and then the processed body of the response.For example, a request like this: Elastic.HTTP.get(&quot;/answer/_search&quot;)Would return a response like this: {:ok, 200, %{&quot;_shards&quot; =&gt; %{&quot;failed&quot; =&gt; 0, &quot;successful&quot; =&gt; 5, &quot;total&quot; =&gt; 5}, &quot;hits&quot; =&gt; %{&quot;hits&quot; =&gt; [%{&quot;_id&quot; =&gt; &quot;1&quot;, &quot;_index&quot; =&gt; &quot;answer&quot;, &quot;_score&quot; =&gt; 1.0, &quot;_source&quot; =&gt; %{&quot;text&quot; =&gt; &quot;I like using Elastic Search&quot;}, &quot;_type&quot; =&gt; &quot;answer&quot;}], &quot;max_score&quot; =&gt; 1.0, &quot;total&quot; =&gt; 1}, &quot;timed_out&quot; =&gt; false, &quot;took&quot; =&gt; 7}}","ref":"Elastic.HTTP.html","title":"Elastic.HTTP","type":"module"},{"doc":"","ref":"Elastic.HTTP.html#add_aws_header/4","title":"Elastic.HTTP.add_aws_header/4","type":"function"},{"doc":"","ref":"Elastic.HTTP.html#add_basic_auth/1","title":"Elastic.HTTP.add_basic_auth/1","type":"function"},{"doc":"","ref":"Elastic.HTTP.html#bulk/1","title":"Elastic.HTTP.bulk/1","type":"function"},{"doc":"Makes a request using the DELETE HTTP method:Elastic.HTTP.delete(&quot;/answers/answer/1&quot;)","ref":"Elastic.HTTP.html#delete/2","title":"Elastic.HTTP.delete/2","type":"function"},{"doc":"Makes a request using the GET HTTP method, and can take a body.Elastic.HTTP.get(&quot;/answer/_search&quot;, body: %{query: ...})","ref":"Elastic.HTTP.html#get/2","title":"Elastic.HTTP.get/2","type":"function"},{"doc":"Makes a request using the HEAD HTTP method:Elastic.HTTP.head(&quot;/answers&quot;)","ref":"Elastic.HTTP.html#head/2","title":"Elastic.HTTP.head/2","type":"function"},{"doc":"Makes a request using the POST HTTP method, and can take a body.","ref":"Elastic.HTTP.html#post/2","title":"Elastic.HTTP.post/2","type":"function"},{"doc":"Makes a request using the PUT HTTP method:Elastic.HTTP.put(&quot;/answers/answer/1&quot;, body: %{ text: &quot;I like using Elastic Search&quot; })","ref":"Elastic.HTTP.html#put/2","title":"Elastic.HTTP.put/2","type":"function"},{"doc":"Collection of functions to work with indices.","ref":"Elastic.Index.html","title":"Elastic.Index","type":"module"},{"doc":"Closes the specified index.","ref":"Elastic.Index.html#close/1","title":"Elastic.Index.close/1","type":"function"},{"doc":"Creates the specified index. If you've configured index_prefix and use_mix_env for Elastic, it will use those.Examples# With index_prefix set to &#39;elastic&#39; # And with `use_mix_env` set to `true` # This will create the `elastic_dev_answer` index Elastic.Index.create(&quot;answer&quot;)","ref":"Elastic.Index.html#create/1","title":"Elastic.Index.create/1","type":"function"},{"doc":"Creates the specified index with optional configuration parameters like settings, mappings, aliases (see the ES Indices API documentation for information on what you can pass). If you've configured index_prefix and use_mix_env for Elastic, it will use those.Examples# With index_prefix set to &#39;elastic&#39; # And with `use_mix_env` set to `true` # This will create the `elastic_dev_answer` index Elastic.Index.create(&quot;answer&quot;, %{settings: {number_of_shards: 2}})","ref":"Elastic.Index.html#create/2","title":"Elastic.Index.create/2","type":"function"},{"doc":"Deletes the specified index. If you've configured index_prefix and use_mix_env for Elastic, it will use those.Examples# With index_prefix set to &#39;elastic&#39; # And with `use_mix_env` set to `true` # This will delete the `elastic_dev_answer` index Elastic.Index.delete(&quot;answer&quot;)","ref":"Elastic.Index.html#delete/1","title":"Elastic.Index.delete/1","type":"function"},{"doc":"Checks if the specified index exists. The index name will be automatically prefixed as per this package's configuration.","ref":"Elastic.Index.html#exists?/1","title":"Elastic.Index.exists?/1","type":"function"},{"doc":"Helper function for getting the name of an index combined with the index_prefix and mix_env configuration.","ref":"Elastic.Index.html#name/1","title":"Elastic.Index.name/1","type":"function"},{"doc":"Opens the specified index.","ref":"Elastic.Index.html#open/1","title":"Elastic.Index.open/1","type":"function"},{"doc":"Refreshes the specified index by issuing a refresh HTTP call.","ref":"Elastic.Index.html#refresh/1","title":"Elastic.Index.refresh/1","type":"function"},{"doc":"Provides Elixir functions for ElasticSearch's scroll endpoint](https://www.elastic.co/guide/en/elasticsearch/reference/2.4/search-request-scroll.html#search-request-scroll). You should probably be using Elastic.Scroller instead.","ref":"Elastic.Scroll.html","title":"Elastic.Scroll","type":"module"},{"doc":"Clears the specified scroll by calling this endpoint Elastic.Scroll.clear(&quot;&lt;Base64 Scroll ID goes here&gt;&quot;) Can also be used to clear multiple scrolls at the same time: Elastic.Scroll.clear([ &quot;&lt;Base64 Scroll ID goes here&gt;&quot;, &quot;&lt;Base64 Scroll ID goes here&gt;&quot; ])","ref":"Elastic.Scroll.html#clear/1","title":"Elastic.Scroll.clear/1","type":"function"},{"doc":"Fetches the next batch of results from a specified scroll. Elastic.Scroll.next(%{ scroll_id: &quot;&lt;a base64 scroll ID goes here&gt;&quot; keepalive: &quot;1m&quot; })","ref":"Elastic.Scroll.html#next/1","title":"Elastic.Scroll.next/1","type":"function"},{"doc":"Starts a new scroll using ElasticSearch's scroll endpoint. Elastic.Scroll.start(%{ index: &quot;answer&quot;, body: %{} # a query can go here size: 100, keepalive: &quot;1m&quot; })","ref":"Elastic.Scroll.html#start/1","title":"Elastic.Scroll.start/1","type":"function"},{"doc":"Provides an API for working with Elastic Search's Scroll APIExample{:ok, pid} = Elastic.Scroller.start_link(%{index: &quot;answer&quot;}) # get the first &quot;page&quot; of results Elastic.Scroller.results(pid) # Request the second page Elastic.Scroller.next_page(pid) # get the second &quot;page&quot; of results Elastic.Scroller.results(pid)Then you can choose to kill the search context yourself... keeping in mind of course that Elastic Search will do this automatically after the keepalive (default of 1 minute) expires for the scroll.Elastic.Scroller.clear(pid)","ref":"Elastic.Scroller.html","title":"Elastic.Scroller","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Elastic.Scroller.html#child_spec/1","title":"Elastic.Scroller.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Elastic.Scroller.html#init/1","title":"Elastic.Scroller.init/1","type":"function"},{"doc":"Fetches the next page of results and returns a scroll ID.To retrieve the results that come from this request, make a call to Elastic.Scroller.results/1.Elastic.Scroller.next_page(pid)","ref":"Elastic.Scroller.html#next_page/1","title":"Elastic.Scroller.next_page/1","type":"function"},{"doc":"Returns the results of the current scroll location.Elastic.Scroller.results(pid)","ref":"Elastic.Scroller.html#results/1","title":"Elastic.Scroller.results/1","type":"function"},{"doc":"Starts an Elastic.Scroller server.For usage information refer to the documentation at the top of this module.","ref":"Elastic.Scroller.html#start_link/1","title":"Elastic.Scroller.start_link/1","type":"function"}]